// DppApiCppDlg.h : header file
//

#pragma once
#include "afxwin.h"
#include ".\plot\PlotCanvas.h"

// CDppApiCppDlg dialog
class CDppApiCppDlg : public CDialog
{
// Construction
public:
	CDppApiCppDlg(CWnd* pParent = NULL);	// standard constructor

// Dialog Data
	enum { IDD = IDD_DPPAPICPP_DIALOG };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support


// Implementation
protected:
	HICON m_hIcon;

	// Generated message map functions
	virtual BOOL OnInitDialog();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	DECLARE_MESSAGE_MAP()
public:
	//CStatic m_PlotPictureControl;
	CPlotCanvas m_PlotPictureControl;
	CPoint CursorPosition;
	afx_msg void OnStnClickedPlotpicturecontrol();
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnBnClickedConfigButton();				// gets config file, configs dpp
	bool PromptFileName();								// creates open file dialog
	CString m_csCurrentFile;							// current file
	afx_msg void OnBnClickedGetdatabutton();			// get spectrum data demonstration 
	UINT m_nElapse;										// data acquisition elapsed time
	UINT_PTR m_nTimerId;								// timer identifier (return value)
	UINT m_nEventId;									// timer (event) identifier					
	void * objDppApi;									// pointer to dpp api
	afx_msg void OnBnClickedStart();					// start data acquisition
	afx_msg void OnBnClickedStop();						// stop data acquisition
	afx_msg void OnTimer(UINT nIDEvent);				// data acquisition timer
	afx_msg void OnBnClickedOk();
	afx_msg void OnBnClickedCancel();
	afx_msg void OnDestroy();		
	void OnQuitDuringAcq();								// shuts down DPPAPI before dialog quits
	void EnableButtons(BOOL bEnable);					// enables/disables dialog buttons
	afx_msg void OnBnClickedPlotscaleradiolinear();		// selects linear plot scale
	afx_msg void OnBnClickedPlotscaleradiolog();		// selects log plot scale
	afx_msg void OnBnClickedPlottyperadiosolid();		// selects solid plot type
	afx_msg void OnBnClickedPlottyperadioline();		// selects line plot type
};

